<?php
///////////////////////////////////////////////////// 
//   PHP myGuestbook 2.0 by Peachy Dandy Software  // 
//            http://www.peachydandy.com           // 
//                                                 // 
//          PHP myGuestbook is a full              // 
//                featured guestbook               // 
//        YOU MAY NOT EDIT, REMOVE OR ALTER        // 
//      OUR COPYRIGHT LINKS WITHOUT PERMISSION     // 
///////////////////////////////////////////////////// 

//
// Start the class
//
class getPaging {

	//
	// Properties
	//
	var $qSelect; // Query
	var $qCount; // Count query
	var $perPage; // Results per page
	var $padding; // Padding beween current and first/last
	var $tmpNav; // Navigation template
	var $tmpPaging; // Paging template
	
	//
	// Constructor
	//
	function getPaging($qSelect, $qCount, $perPage, $padding, $tmpNav, $tmpPaging){
		
		$this->results = $qSelect;
		$this->count = $qCount;
		$this->perPage = $perPage;
		$this->padding = $padding;
		$this->curPage = (isset($_GET['page']) && is_numeric($_GET['page'])) ? $_GET['page'] : 1;
		
		$this->tmpNav = array("before" => "".$tmpNav['before']."",
		"after"  => "".$tmpNav['after']."");
		
		$this->tmpPaging = array("before" => "".$tmpPaging['before']."",
		"after"  => "".$tmpPaging['after']."");
	
	}
	
	//
	// Get total number of pages
	//
	function getNumPages(){
	
		// Count
		$countIt = mysql_query($this->count);
		$totalCount = mysql_fetch_object($countIt);

		return ceil($totalCount->total / $this->perPage); // Return calculated result
	}
	
	//
	// Get total number of rows
	//
	function getNumRows(){
	
		// Count
		$countIt = mysql_query($this->count);
		$totalCount = mysql_fetch_object($countIt);

		return $totalCount->total;
	}
	
	//
	// Fetch array, returns the complete mysql query to use outside this class
	//
	function fetchArray(){
    
		$index = ($this->curPage * $this->perPage) - $this->perPage;

		return "$this->results LIMIT $index, $this->perPage";
	
    }
	
	//
	// Show navigation, e.g "Showing 0 - 8 of 16 messages"
	//
	function showNav(){
		
		// Total rows
		$total = $this->getNumRows();
		
		// Calculate what number we begins with
		$from = ($this->curPage * $this->perPage) - $this->perPage;
		
		// Calculate the last number on current page
		$to = $from + $this->perPage;
	
		$showNav = '<span>Showing '.$from.' - '.$to.' of '.$total.' messages</span>';
	
		// Return navigation, with template
		return $this->tmpNav['before'] . $showNav . $this->tmpNav['after'];
	
	}
	
	//
	// Function to display the paging
	//
	function displayPaging(){
		
		$nav = '';
		$totalPages = $this->getNumPages(); // Total pages
		
		// If the current page is more than total pages, show page 1
		if ($this->curPage > $totalPages){
			$this->curPage = 1;
		}
	
		//
		// First page
		//
		if ($totalPages > 1){
			if ($this->curPage != 1){
				$nav .= '<a href="?page=1">1</a>';
			}
			else{
				$nav .= '<span class="current">1</span>';
			}
		}
		
		//
		// Links before current and padding
		//
		if ($this->curPage <= 1 + $this->padding){
			for ($i = 2;$i<$this->curPage;$i++){
				$nav .= ' <a href="?page='.$i.'">'.$i.'</a> ';
			}
		}
		else{
			$nav .= " ... ";
			for ($i=$this->curPage-$this->padding;$i<$this->curPage;$i++){
				$nav .= ' <a href="?page='.$i.'">'.$i.'</a> ';
			}
		}
		
		//
		// Current page
		//
		if (($this->curPage != 1) && ($this->curPage != $totalPages)){
			$nav .= " <span class=\"current\"><strong>".$this->curPage."</strong></span> ";
		}
	
		//
		// After current and padding
		//
		if ($this->curPage >= $totalPages - $this->padding){
			for ($i = $this->curPage + 1;$i<$totalPages;$i++){
				$nav .= ' <a href="?page='.$i.'">'.$i.'</a> ';
			}
		}
		else{
			for ($i=$this->curPage+1;$i<$this->curPage+$this->padding;$i++){
				$nav .= ' <a href="?page='.$i.'">'.$i.'</a> ';
			}
			$nav .= " ... ";
		}
		
		//
		// Last page
		//
		if ($totalPages > 1){
			if ($this->curPage != $totalPages){
				$nav .= ' <a href="?page='.$totalPages.'">'.$totalPages.'</a>';
			}
			else{
				$nav .= ' <span class="current">'.$totalPages.'</span>';
			}
		}
		
		// Return paging with template
		return $this->tmpPaging['before'] . $nav . $this->tmpPaging['after'];
	}
	
}
?>